'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _fbInit = require('./../../utils/fbInit');

var _fbInit2 = _interopRequireDefault(_fbInit);

var _MessengerPluginEvents = require('./../../constants/MessengerPluginEvents');

var MessengerPluginEvents = _interopRequireWildcard(_MessengerPluginEvents);

var _ClassNames = require('./../../constants/ClassNames');

var ClassNames = _interopRequireWildcard(_ClassNames);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomerChatPlugin = function (_Component) {
  _inherits(CustomerChatPlugin, _Component);

  function CustomerChatPlugin() {
    _classCallCheck(this, CustomerChatPlugin);

    return _possibleConstructorReturn(this, (CustomerChatPlugin.__proto__ || Object.getPrototypeOf(CustomerChatPlugin)).apply(this, arguments));
  }

  _createClass(CustomerChatPlugin, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(props) {
      this.shouldPluginUpdate(props);

      var componentAffectProps = ['className', 'pluginClassName', 'pageId', 'dataRef', 'mimimize'];
      return !(0, _isEqual2.default)((0, _pick2.default)(this.props, componentAffectProps), (0, _pick2.default)(props, componentAffectProps));
    }
  }, {
    key: 'shouldPluginUpdate',
    value: function shouldPluginUpdate(props) {
      var pluginAffectProps = ['pageId', 'dataRef', 'mimimize'];

      var isPluginAffected = !(0, _isEqual2.default)((0, _pick2.default)(this.props, pluginAffectProps), (0, _pick2.default)(props, pluginAffectProps));

      if (isPluginAffected) {
        (0, _fbInit2.default)(props);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _fbInit2.default)(this.props);
      this.subscribe();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unsubscribe();
    }
  }, {
    key: 'subscribe',
    value: function subscribe() {
      window.FB.Event.subscribe('customerchat', this.handleEvents.bind(this));
    }
  }, {
    key: 'unsubscribe',
    value: function unsubscribe() {
      window.FB.Event.unsubscribe('customerchat', this.handleEvents.bind(this));
    }
  }, {
    key: 'handleEvents',
    value: function handleEvents(event) {
      if (!event.ref || event.ref !== this.props.dataRef) {
        return;
      }

      if (event.event === MessengerPluginEvents.HIDDEN) {
        this.props.onHide(event);
      }

      if (event.event === MessengerPluginEvents.RENDERED) {
        this.props.onRender(event);
      }
    }
  }, {
    key: 'getSnippet',
    value: function getSnippet() {
      var _props = this.props,
          id = _props.id,
          pageId = _props.pageId,
          dataRef = _props.dataRef,
          mimimize = _props.mimimize;


      return '<div\n          id=\'' + id + '\'\n          class=\'' + ClassNames.CUSTOMER_CHAT_PLUGIN + '\'\n          page_id=\'' + pageId + '\'\n          data-ref=\'' + dataRef + '\'\n          ' + (mimimize ? 'mimimize=\'' + mimimize + '\'' : '') + '></div>';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          pluginClassName = _props2.pluginClassName;


      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement('div', { className: pluginClassName, dangerouslySetInnerHTML: { __html: this.getSnippet() } })
      );
    }
  }]);

  return CustomerChatPlugin;
}(_react.Component);

exports.default = CustomerChatPlugin;


CustomerChatPlugin.propTypes = {
  className: _propTypes2.default.string,
  pluginClassName: _propTypes2.default.string,

  id: _propTypes2.default.string,
  pageId: _propTypes2.default.string.isRequired,
  dataRef: _propTypes2.default.string.isRequired,
  mimimize: _propTypes2.default.bool,

  onHide: _propTypes2.default.func,
  onRender: _propTypes2.default.func
};

CustomerChatPlugin.defaultProps = {
  id: '',
  className: '',
  pluginClassName: '',

  mimimize: null,

  onHide: _noop2.default,
  onRender: _noop2.default
};
//# sourceMappingURL=CustomerChatPlugin.js.map