'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _values = require('lodash/values');

var _values2 = _interopRequireDefault(_values);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _fbInit = require('./../../utils/fbInit');

var _fbInit2 = _interopRequireDefault(_fbInit);

var _MessengerPluginTypes = require('./../../constants/MessengerPluginTypes');

var MessengerPluginTypes = _interopRequireWildcard(_MessengerPluginTypes);

var _MessengerPluginEvents = require('./../../constants/MessengerPluginEvents');

var MessengerPluginEvents = _interopRequireWildcard(_MessengerPluginEvents);

var _MessengerPluginSize = require('./../../constants/MessengerPluginSize');

var MessengerPluginSize = _interopRequireWildcard(_MessengerPluginSize);

var _MessengerPluginColor = require('./../../constants/MessengerPluginColor');

var MessengerPluginColor = _interopRequireWildcard(_MessengerPluginColor);

var _ClassNames = require('./../../constants/ClassNames');

var ClassNames = _interopRequireWildcard(_ClassNames);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FacebookMessengerPlugin = function (_Component) {
  _inherits(FacebookMessengerPlugin, _Component);

  function FacebookMessengerPlugin() {
    _classCallCheck(this, FacebookMessengerPlugin);

    return _possibleConstructorReturn(this, (FacebookMessengerPlugin.__proto__ || Object.getPrototypeOf(FacebookMessengerPlugin)).apply(this, arguments));
  }

  _createClass(FacebookMessengerPlugin, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(props) {
      this.shouldPluginUpdate(props);

      var componentAffectProps = ['className', 'pluginClassName', 'type', 'id', 'appId', 'pageId', 'dataRef', 'size', 'color', 'prechecked'];
      return !(0, _isEqual2.default)((0, _pick2.default)(this.props, componentAffectProps), (0, _pick2.default)(props, componentAffectProps));
    }
  }, {
    key: 'shouldPluginUpdate',
    value: function shouldPluginUpdate(props) {
      var pluginAffectProps = ['type', 'appId', 'pageId', 'dataRef', 'size', 'color', 'prechecked'];

      var isPluginAffected = !(0, _isEqual2.default)((0, _pick2.default)(this.props, pluginAffectProps), (0, _pick2.default)(props, pluginAffectProps));

      if (isPluginAffected) {
        (0, _fbInit2.default)(props);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _fbInit2.default)(this.props);
      this.subscribe();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unsubscribe();
    }
  }, {
    key: 'subscribe',
    value: function subscribe() {
      window.FB.Event.subscribe('messenger_checkbox', this.handleCheckboxEvents.bind(this));
      window.FB.Event.subscribe('send_to_messenger', this.handleButtonEvents.bind(this));
    }
  }, {
    key: 'unsubscribe',
    value: function unsubscribe() {
      window.FB.Event.unsubscribe('messenger_checkbox', this.handleCheckboxEvents.bind(this));
      window.FB.Event.unsubscribe('send_to_messenger', this.handleButtonEvents.bind(this));
    }
  }, {
    key: 'handleCheckboxEvents',
    value: function handleCheckboxEvents(event) {
      if (!event.ref || event.ref !== this.props.dataRef) {
        return;
      }

      if (event.event === MessengerPluginEvents.CHECKBOX) {
        var checked = event.state == 'checked';
        this.props.onChecked(checked, event);
      }

      if (event.event === MessengerPluginEvents.HIDDEN) {
        this.props.onHide(event);
      }

      if (event.event === MessengerPluginEvents.RENDERED) {
        this.props.onRender(event);
      }
    }
  }, {
    key: 'handleButtonEvents',
    value: function handleButtonEvents(event) {
      if (!event.ref || event.ref !== this.props.dataRef) {
        return;
      }

      if (event.event === MessengerPluginEvents.CLICKED) {
        return this.props.onSubmit(event);
      }

      if (event.event === MessengerPluginEvents.HIDDEN) {
        return this.props.onHide(event);
      }

      if (event.event === MessengerPluginEvents.RENDERED) {
        return this.props.onRender(event);
      }
    }
  }, {
    key: 'getSnippet',
    value: function getSnippet() {
      var _props = this.props,
          type = _props.type,
          id = _props.id,
          appId = _props.appId,
          pageId = _props.pageId,
          dataRef = _props.dataRef,
          size = _props.size,
          color = _props.color,
          prechecked = _props.prechecked;


      if (type === MessengerPluginTypes.CHECKBOX) {
        return '<div\n          id=\'' + id + '\'\n          class=\'' + ClassNames.CHECKBOX_PLUGIN + '\'\n          messenger_app_id=\'' + appId + '\'\n          page_id=\'' + pageId + '\'\n          origin=\'' + window.location.origin + '\'\n          data-ref=\'' + dataRef + '\'\n          size=' + size + '\n          prechecked=\'' + JSON.stringify(prechecked) + '\'\n          allow_login=\'true\'></div>';
      }

      if (type === MessengerPluginTypes.BUTTON) {
        return '<div\n          id=\'' + id + '\'\n          class=\'' + ClassNames.SEND_TO_MESSENGER_PLUGIN + '\'\n          messenger_app_id=\'' + appId + '\'\n          page_id=\'' + pageId + '\'\n          data-ref=\'' + dataRef + '\'\n          color=\'' + color + '\'\n          size=\'' + size + '\'></div>';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          pluginClassName = _props2.pluginClassName;


      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement('div', { className: pluginClassName, dangerouslySetInnerHTML: { __html: this.getSnippet() } })
      );
    }
  }]);

  return FacebookMessengerPlugin;
}(_react.Component);

exports.default = FacebookMessengerPlugin;


FacebookMessengerPlugin.propTypes = {
  className: _propTypes2.default.string,
  pluginClassName: _propTypes2.default.string,

  type: _propTypes2.default.oneOf((0, _values2.default)(MessengerPluginTypes)),
  id: _propTypes2.default.string.isRequired,
  appId: _propTypes2.default.string.isRequired,
  pageId: _propTypes2.default.string.isRequired,
  dataRef: _propTypes2.default.string.isRequired,
  size: _propTypes2.default.oneOf((0, _values2.default)(MessengerPluginSize)),
  color: _propTypes2.default.oneOf((0, _values2.default)(MessengerPluginColor)), // button specific
  prechecked: _propTypes2.default.bool, // checkbox specific

  onSubmit: _propTypes2.default.func, // button specific
  onChecked: _propTypes2.default.func, // checkbox specific
  onHide: _propTypes2.default.func,
  onRender: _propTypes2.default.func
};

FacebookMessengerPlugin.defaultProps = {
  className: '',
  pluginClassName: '',

  type: MessengerPluginTypes.BUTTON,
  size: MessengerPluginSize.LARGE,
  color: MessengerPluginColor.WHITE,
  prechecked: true,

  onSubmit: _noop2.default,
  onChecked: _noop2.default,
  onHide: _noop2.default,
  onRender: _noop2.default
};
//# sourceMappingURL=MessengerPlugin.js.map