'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _values = require('lodash/values');

var _values2 = _interopRequireDefault(_values);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _fbInit = require('./../../utils/fbInit');

var _fbInit2 = _interopRequireDefault(_fbInit);

var _ShareButtonSize = require('./../../constants/ShareButtonSize');

var ShareButtonSize = _interopRequireWildcard(_ShareButtonSize);

var _ShareButtonLayout = require('./../../constants/ShareButtonLayout');

var ShareButtonLayout = _interopRequireWildcard(_ShareButtonLayout);

var _ClassNames = require('./../../constants/ClassNames');

var ClassNames = _interopRequireWildcard(_ClassNames);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ShareButton = function (_Component) {
  _inherits(ShareButton, _Component);

  function ShareButton() {
    _classCallCheck(this, ShareButton);

    return _possibleConstructorReturn(this, (ShareButton.__proto__ || Object.getPrototypeOf(ShareButton)).apply(this, arguments));
  }

  _createClass(ShareButton, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(props) {
      this.shouldPluginUpdate(props);

      var componentAffectProps = ['href', 'layout', 'mobileIframe', 'size', 'className'];
      return !(0, _isEqual2.default)((0, _pick2.default)(this.props, componentAffectProps), (0, _pick2.default)(props, componentAffectProps));
    }
  }, {
    key: 'shouldPluginUpdate',
    value: function shouldPluginUpdate(props) {
      var pluginAffectProps = ['href', 'layout', 'mobileIframe', 'size'];

      var isPluginAffected = !(0, _isEqual2.default)((0, _pick2.default)(this.props, pluginAffectProps), (0, _pick2.default)(props, pluginAffectProps));

      if (isPluginAffected) {
        (0, _fbInit2.default)(props);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _fbInit2.default)(this.props);
    }
  }, {
    key: 'getSnippet',
    value: function getSnippet() {
      var _props = this.props,
          href = _props.href,
          layout = _props.layout,
          mobileIframe = _props.mobileIframe,
          size = _props.size;


      return '<div\n        class=\'' + ClassNames.SHARE_BUTTON + '\'\n        data-href=\'' + href + '\'\n        data-layout=\'' + layout + '\'\n        data-mobile_iframe=\'' + JSON.stringify(mobileIframe) + '\'\n        data-size=\'' + size + '\'></div>';
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: this.props.className },
        _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.getSnippet() } })
      );
    }
  }]);

  return ShareButton;
}(_react.Component);

exports.default = ShareButton;


ShareButton.propTypes = {
  appId: _propTypes2.default.string.isRequired,
  href: _propTypes2.default.string.isRequired,
  layout: _propTypes2.default.oneOf((0, _values2.default)(ShareButtonLayout)),
  mobileIframe: _propTypes2.default.bool.isRequired,
  size: _propTypes2.default.oneOf((0, _values2.default)(ShareButtonSize)),
  className: _propTypes2.default.string
};

ShareButton.defaultProps = {
  mobileIframe: false,
  layout: ShareButtonLayout.BUTTON,
  size: ShareButtonSize.SMALL
};
//# sourceMappingURL=ShareButton.js.map