import random from 'lodash/random'
import debounce from 'lodash/debounce'
import each from 'lodash/each'
import * as ClassNames from './../constants/ClassNames'


let intIndex = random(9000000, 9000000000000000)

function randomInt() {
  intIndex = intIndex + 1
  return intIndex
}

export const updateUserRef = () => {
  // перед вызовом FB.init нужно сгенерировать новые user_ref для чекбоксов, иначе они не отрендерятся
  const elements = document.getElementsByClassName(ClassNames.CHECKBOX_PLUGIN)
  each(elements, (element) => element.setAttribute('user_ref', -randomInt()))
}

export const removeCustomerChatClass = () => {
  // удаляем класс fb-customerchat для отрендеренных плагинов, иначе они исчезнуть после вызова FB.init
  const elements = document.getElementsByClassName(ClassNames.CUSTOMER_CHAT_PLUGIN)
  each(elements, (element) => {
    if (element.getAttribute('fb-xfbml-state')) {
      element.classList.remove('fb-customerchat')
    }
  })
}


const fbInitDebounced = debounce(({appId}) => {
  updateUserRef()
  removeCustomerChatClass()
  const xfbml = true
  const version = 'v2.6'
  window.FB.init({appId, xfbml, version})
}, 500)


export default fbInitDebounced